//----------------------------------------------------------------------------//
// ( c ) Cristobal Navarro 2018
// 17/03/2018 Ver.
// Sample use All Class TGGraphics
//----------------------------------------------------------------------------//

#include "Fivewin.ch"
#include "colores.ch"
#include "Constant.ch"

Static oWnd
Static oFnt
Static aGraphs   := {}
Static oBrwG

//----------------------------------------------------------------------------//

Function Main()

   DEFINE FONT oFnt NAME "Segoe UI Symbol" SIZE 0, -18

   // Create Graphs: functions return address web
   AAdd( aGraphs, { "01.- Maps Chart Simple", Map1() } )
   AAdd( aGraphs, { "02.- Maps Chart France", Map2() } )
   AAdd( aGraphs, { "03.- Maps Chart Spain", Map3() } )
   AAdd( aGraphs, { "04.- Maps Chart Fw", Map4() } )
   AAdd( aGraphs, { "01.- Simple QR Code" + CRLF + "QrCode1" + "128 x 128" + " Margin 0" + CRLF + "Margin Default: 4", QrCode1() } )
   AAdd( aGraphs, { "02.- QR Code" + CRLF + "QrCode2" + "128 x 128" + " Margin 10", QrCode2() } )
   AAdd( aGraphs, { "03.- QR Code" + CRLF + "QrCode3" + "128 x 128" + " Margin 5" + CRLF + "Color", QrCode3() } )
   AAdd( aGraphs, { "01.- Simple Pie Chart 3D Simple", Pie1() } )
   AAdd( aGraphs, { "02.- Pie Chart 3D with Legends" , Pie2() } )
   AAdd( aGraphs, { "03.- Pie Chart 3D with Legends" , Pie3() } )
   AAdd( aGraphs, { "04.- Pie Chart 3D with Legends" , Pie4() } )
   AAdd( aGraphs, { "05.- Pie Chart 3D with Legends" + CRLF + "Rotation 60" , Pie5() } )
   AAdd( aGraphs, { "06.- Pie Chart 3D with Legends" , Pie6() } )
   AAdd( aGraphs, { "01.- Simple Pie Chart Simple", Pie1( .F. ) } )
   AAdd( aGraphs, { "02.- Pie Chart with Legends" , Pie2( .F. ) } )
   AAdd( aGraphs, { "03.- Pie Chart with Legends" , Pie3( .F. ) } )
   AAdd( aGraphs, { "04.- Pie Chart with Legends" , Pie4( .F. ) } )
   AAdd( aGraphs, { "05.- Pie Chart with Legends" + CRLF + "Rotation 60", Pie5( .F. ) } )
   AAdd( aGraphs, { "06.- Pie Chart with Legends" , Pie6( .F. ) } )
   AAdd( aGraphs, { "01.- Simple Bar Chart Horizontal", Bar1() } )
   AAdd( aGraphs, { "02.- Bar Chart Horizontal with Legends" , Bar2() } )
   AAdd( aGraphs, { "03.- Bar Chart Horizontal with Legends" , Bar3() } )
   AAdd( aGraphs, { "04.- Bar Chart Horizontal with Legends" , Bar4() } )
   AAdd( aGraphs, { "05.- Bar Chart Horizontal with Legends" , Bar5() } )
   AAdd( aGraphs, { "06.- Bar Chart Horizontal with Legends" , Bar6() } )
   AAdd( aGraphs, { "01.- Simple Bar Chart Vertical", Bar1( .T. ) } )
   AAdd( aGraphs, { "02.- Bar Chart Vertical with Legends" , Bar2( .T. ) } )
   AAdd( aGraphs, { "03.- Bar Chart Vertical with Legends" , Bar3( .T. ) } )
   AAdd( aGraphs, { "04.- Bar Chart Vertical with Legends" , Bar4( .T. ) } )
   AAdd( aGraphs, { "05.- Bar Chart Vertical with Legends" , Bar5( .T. ) } )
   AAdd( aGraphs, { "06.- Bar Chart Vertical with Legends" , Bar6( .T. ) } )
   AAdd( aGraphs, { "01.- Line Chart Simple", Lin1() } )
   AAdd( aGraphs, { "02.- Line Chart with Legends" , Lin2() } )
   AAdd( aGraphs, { "03.- Line Chart with Legends" , Lin3() } )
   AAdd( aGraphs, { "01.- Line Chart Simple Not Axils", Lin1( .F. ) } )
   AAdd( aGraphs, { "02.- Line Chart with Legends Not Axils" , Lin2( .F. ) } )
   AAdd( aGraphs, { "03.- Line Chart with Legends Not Axils" , Lin3( .F. ) } )
   AAdd( aGraphs, { "01.- Venn Chart Simple", Ven1() } )
   AAdd( aGraphs, { "02.- Venn Chart with Legends" , Ven2() } )
   AAdd( aGraphs, { "03.- Venn Chart with Legends" , Ven3() } )
   AAdd( aGraphs, { "01.- OMetter Chart with Legends" , Met1() } )
   AAdd( aGraphs, { "02.- OMetter Chart with Legends" , Met2() } )
   AAdd( aGraphs, { "03.- OMetter Chart with Legends" , Met3() } )
   AAdd( aGraphs, { "01.- Formula Chart" , For1() } )
   AAdd( aGraphs, { "02.- Formula Chart" , For2() } )
   AAdd( aGraphs, { "03.- Formula Chart" , For3() } )
   AAdd( aGraphs, { "04.- Formula Chart" , For4() } )
   AAdd( aGraphs, { "01.- Scatter Chart" , Sca1() } )
   AAdd( aGraphs, { "02.- Scatter Chart" , Sca2() } )
   AAdd( aGraphs, { "03.- Scatter Chart" , Sca3() } )
   AAdd( aGraphs, { "04.- Scatter Chart" , Sca4() } )
   AAdd( aGraphs, { "01.- Radar Chart Lines" , Rad1() } )
   AAdd( aGraphs, { "02.- Radar Chart Lines" , Rad2() } )
   AAdd( aGraphs, { "03.- Radar Chart Curve" , Rad3() } )
   AAdd( aGraphs, { "01.- GraphViz Chart dot" , Viz1() } )
   AAdd( aGraphs, { "02.- GraphViz Chart neato" , Viz2() } )
   AAdd( aGraphs, { "03.- GraphViz Chart twopi" , Viz3() } )
   AAdd( aGraphs, { "04.- GraphViz Chart circo" , Viz4() } )
   AAdd( aGraphs, { "05.- GraphViz Chart fdp" , Viz5() } )
   AAdd( aGraphs, { "06.- GraphViz Chart dot Complex" , Viz6() } )
   AAdd( aGraphs, { "07.- GraphViz Chart dot More Complex" , Viz7() } )
   AAdd( aGraphs, { "08.- GraphViz Chart neato Complex" , Viz8() } )

   AAdd( aGraphs, { "01.- Bubble Chart tail at bottom left" , Bubble01() } )
   AAdd( aGraphs, { "02.- Bubble Chart tail at top left" , Bubble01( , "t", "l" ) } )
   AAdd( aGraphs, { "03.- Bubble Chart tail at top right" , Bubble01( , "t", "r" ) } )
   AAdd( aGraphs, { "04.- Bubble Chart tail at bottom righ" , Bubble01( , "b", "r" ) } )
   AAdd( aGraphs, { "05.- Bubble Chart no tail" , Bubble01( , "T", ) } )

   AAdd( aGraphs, { "06.- Bubble Chart Edge tail at bottom left" , Bubble01( .T., "b", "l" ) } )
   AAdd( aGraphs, { "07.- Bubble Chart Edge tail at botton center" , Bubble01( .T., "b", "c" ) } )
   AAdd( aGraphs, { "08.- Bubble Chart Edge tail at bottom right" , Bubble01( .T., "b", "r" ) } )
   AAdd( aGraphs, { "09.- Bubble Chart Edge tail at top left" , Bubble01( .T., "t", "l" ) } )
   AAdd( aGraphs, { "10.- Bubble Chart Edge tail at top center" , Bubble01( .T., "t", "c" ) } )
   AAdd( aGraphs, { "11.- Bubble Chart Edge tail at top right" , Bubble01( .T., "t", "r" ) } )
   AAdd( aGraphs, { "12.- Bubble Chart Edge tail at left top" , Bubble01( .T., "l", "t" ) } )
   AAdd( aGraphs, { "13.- Bubble Chart Edge tail at left center" , Bubble01( .T., "l", "c" ) } )
   AAdd( aGraphs, { "14.- Bubble Chart Edge tail at left bottom" , Bubble01( .T., "l", "b" ) } )
   AAdd( aGraphs, { "15.- Bubble Chart Edge tail at right top" , Bubble01( .T., "r", "t" ) } )
   AAdd( aGraphs, { "16.- Bubble Chart Edge tail at right center" , Bubble01( .T., "r", "c" ) } )
   AAdd( aGraphs, { "17.- Bubble Chart Edge tail at right bottom" , Bubble01( .T., "r", "b" ) } )

   AAdd( aGraphs, { "18.- Bubble Chart Icon tail at bottom left" , Bubble01( ,,, .T. ) } )
   AAdd( aGraphs, { "19.- Bubble Chart Icon tail at top left" , Bubble01( , "t", "l", .T. ) } )
   AAdd( aGraphs, { "20.- Bubble Chart Icon tail at top right" , Bubble01( , "t", "r", .T. ) } )
   AAdd( aGraphs, { "21.- Bubble Chart Icon tail at bottom righ" , Bubble01( , "b", "r", .T. ) } )
   AAdd( aGraphs, { "22.- Bubble Chart Icon no tail" , Bubble01( , "T", , .T. ) } )

   AAdd( aGraphs, { "23.- Bubble Chart Icon Edge tail at bottom left" , Bubble01( .T., "b", "l", .T. ) } )
   AAdd( aGraphs, { "24.- Bubble Chart Icon Edge tail at botton center" , Bubble01( .T., "b", "c", .T. ) } )
   AAdd( aGraphs, { "25.- Bubble Chart Icon Edge tail at bottom right" , Bubble01( .T., "b", "r", .T. ) } )
   AAdd( aGraphs, { "26.- Bubble Chart Icon Edge tail at top left" , Bubble01( .T., "t", "l", .T. ) } )
   AAdd( aGraphs, { "27.- Bubble Chart Icon Edge tail at top center" , Bubble01( .T., "t", "c", .T. ) } )
   AAdd( aGraphs, { "28.- Bubble Chart Icon Edge tail at top right" , Bubble01( .T., "t", "r", .T. ) } )
   AAdd( aGraphs, { "29.- Bubble Chart Icon Edge tail at left top" , Bubble01( .T., "l", "t", .T. ) } )
   AAdd( aGraphs, { "30.- Bubble Chart Icon Edge tail at left center" , Bubble01( .T., "l", "c", .T. ) } )
   AAdd( aGraphs, { "31.- Bubble Chart Icon Edge tail at left bottom" , Bubble01( .T., "l", "b", .T. ) } )
   AAdd( aGraphs, { "32.- Bubble Chart Icon Edge tail at right top" , Bubble01( .T., "r", "t", .T. ) } )
   AAdd( aGraphs, { "33.- Bubble Chart Icon Edge tail at right center" , Bubble01( .T., "r", "c", .T. ) } )
   AAdd( aGraphs, { "34.- Bubble Chart Icon Edge tail at right bottom" , Bubble01( .T., "r", "b", .T. ) } )

   AAdd( aGraphs, { "35.- Bubble Chart Shadow tail at bottom left" , Bubble01(,,,, .T. ) } )
   AAdd( aGraphs, { "36.- Bubble Chart Shadow tail at top left" , Bubble01( , "t", "l", , .T. ) } )
   AAdd( aGraphs, { "37.- Bubble Chart Shadow Icon tail at bottom left" , Bubble01( ,,, .T., .T. ) } )
   AAdd( aGraphs, { "38.- Bubble Chart Shadow Icon tail at top left" , Bubble01( , "t", "l", .T., .T. ) } )
   AAdd( aGraphs, { "39.- Bubble Chart Shadow Icon Edge tail at right center" , Bubble01( .T., "r", "c", .T., .T. ) } )
   AAdd( aGraphs, { "40.- Bubble Chart Shadow Icon Edge tail at right bottom" , Bubble01( .T., "l", "b", .T., .T. ) } )

   AAdd( aGraphs, { "01.- Fun Notes Chart Arrow   No Title Big" , FNotes01() } )
   AAdd( aGraphs, { "02.- Fun Notes Chart Ballon  No Title Big" , FNotes01( "balloon"  ) } )
   AAdd( aGraphs, { "03.- Fun Notes Chart Pinned  No Title Big" , FNotes01( "pinned_c" ) } )
   AAdd( aGraphs, { "04.- Fun Notes Chart Sticky  No Title Big" , FNotes01( "sticky_y" ) } )
   AAdd( aGraphs, { "05.- Fun Notes Chart Taped   No Title Big" , FNotes01( "taped_y"  ) } )
   AAdd( aGraphs, { "06.- Fun Notes Chart Thought No Title Big" , FNotes01( "thought" ) } )
   AAdd( aGraphs, { "07.- Fun Notes Chart Arrow   W/Title Big" , FNotes01(,.T.,,) } )
   AAdd( aGraphs, { "08.- Fun Notes Chart Ballon  W/Title Big" , FNotes01( "balloon",.T.,, ) } )
   AAdd( aGraphs, { "09.- Fun Notes Chart Pinned  W/Title Big" , FNotes01( "pinned_c",.T.,, "h") } )
   AAdd( aGraphs, { "10.- Fun Notes Chart Sticky  W/Title Big" , FNotes01( "sticky_y",.T.,, "r") } )
   AAdd( aGraphs, { "11.- Fun Notes Chart Taped   W/Title Big" , FNotes01( "taped_y",.T.,, "h" ) } )
   AAdd( aGraphs, { "12.- Fun Notes Chart Thought W/Title Big" , FNotes01( "thought",.T.,, "r" ) } )

   AAdd( aGraphs, { "13.- Fun Notes Chart Arrow   No Title Small" , FNotes01(,,.F.,) } )
   AAdd( aGraphs, { "14.- Fun Notes Chart Ballon  No Title Small" , FNotes01( "balloon",,.F., "h" ) } )
   AAdd( aGraphs, { "15.- Fun Notes Chart Pinned  No Title Small" , FNotes01( "pinned_c",,.F., "r") } )
   AAdd( aGraphs, { "16.- Fun Notes Chart Sticky  No Title Small" , FNotes01( "sticky_y",,.F., ) } )
   AAdd( aGraphs, { "17.- Fun Notes Chart Taped   No Title Small" , FNotes01( "taped_y",,.F., "h" ) } )
   AAdd( aGraphs, { "18.- Fun Notes Chart Thought No Title Small" , FNotes01( "thought",,.F., "r" ) } )
   AAdd( aGraphs, { "19.- Fun Notes Chart Arrow   W/Title  Small" , FNotes01(,.T.,,) } )
   AAdd( aGraphs, { "20.- Fun Notes Chart Ballon  W/Title  Small" , FNotes01( "balloon",.T.,.F., ) } )
   AAdd( aGraphs, { "21.- Fun Notes Chart Pinned  W/Title  Small" , FNotes01( "pinned_c",.T.,.F., "h" ) } )
   AAdd( aGraphs, { "22.- Fun Notes Chart Sticky  W/Title  Small" , FNotes01( "sticky_y",.T.,.F., "r" ) } )
   AAdd( aGraphs, { "23.- Fun Notes Chart Taped   W/Title  Small" , FNotes01( "taped_y",.T.,.F.,  ) } )
   AAdd( aGraphs, { "24.- Fun Notes Chart Thought W/Title  Small" , FNotes01( "thought",.T.,.F., "h" ) } )

   AAdd( aGraphs, { "01.- OutLine Text Normal" , OutTxt01() } )
   AAdd( aGraphs, { "02.- OutLine Text Bold  " , OutTxt01(.T.,) } )
   AAdd( aGraphs, { "03.- OutLine Text Normal Right" , OutTxt01( , "r" ) } )
   AAdd( aGraphs, { "04.- OutLine Text Bold Centerd" , OutTxt01( .T., "h" ) } )
   
   AAdd( aGraphs, { "01.- OutLine Text Icon" , OutTxtIco01( , , ) } )
   AAdd( aGraphs, { "02.- OutLine Text Icon" , OutTxtIco01( "above", "16", "l") } )
   AAdd( aGraphs, { "03.- OutLine Text Icon" , OutTxtIco01( "left", "24", "h") } )
   AAdd( aGraphs, { "04.- OutLine Text Icon" , OutTxtIco01( "right", , "r") } )

   AAdd( aGraphs, { "01.- Weather Notes" , Weather01( ,  ) } )
   AAdd( aGraphs, { "02.- Weather Notes" , Weather01( , "clear-night-moon" ) } )
   AAdd( aGraphs, { "03.- Weather Notes" , Weather01( "balloon", "cloudy-heavy" ) } )
   AAdd( aGraphs, { "04.- Weather Notes" , Weather01( "pinned_c", "cloudy-sunny" ) } )
   AAdd( aGraphs, { "05.- Weather Notes" , Weather01( "pinned_c", "cloudy" ) } )
   AAdd( aGraphs, { "06.- Weather Notes" , Weather01( "sticky_y", "rain" ) } )
   AAdd( aGraphs, { "07.- Weather Notes" , Weather01( "taped_y", "rainy-sunny" ) } )
   AAdd( aGraphs, { "08.- Weather Notes" , Weather01( "balloon", "snow" ) } )
   AAdd( aGraphs, { "09.- Weather Notes" , Weather01( "sticky_y", "snowflake" ) } )
   AAdd( aGraphs, { "10.- Weather Notes" , Weather01( "taped_y", "snowy-sunny" ) } )
   AAdd( aGraphs, { "11.- Weather Notes" , Weather01( "balloon", "sunny-cloudy" ) } )
   AAdd( aGraphs, { "12.- Weather Notes" , Weather01( "thought", "thermometer-cold" ) } )
   AAdd( aGraphs, { "13.- Weather Notes" , Weather01( "pinned_c", "thermometer-hot" ) } )
   AAdd( aGraphs, { "14.- Weather Notes" , Weather01( "sticky_y", "thunder" ) } )
   AAdd( aGraphs, { "15.- Weather Notes" , Weather01( "thought", "windy" ) } )

   AAdd( aGraphs, { "01.- Pings" , Ping01() } )
   AAdd( aGraphs, { "02.- Pings Factor 2" , Ping01( "2" ) } )
   AAdd( aGraphs, { "03.- Pings Star" , Ping02() } )
   AAdd( aGraphs, { "04.- Pings SLeft" , Ping03() } )
   AAdd( aGraphs, { "05.- Pings SRight" , Ping04() } )
   AAdd( aGraphs, { "06.- Pings Factor 3" , Ping05( "3" ) } )
   AAdd( aGraphs, { "07.- Pings Spin" , Ping06(  ) } )
   AAdd( aGraphs, { "08.- Pings Spin" , Ping07(  ) } )
   AAdd( aGraphs, { "09.- Pings Only Shadow" , Ping08() } )

   DEFINE WINDOW oWnd TITLE "Gallery Charting Graphs API Google" FROM 20, 10 TO 740, 1350 PIXEL ;
      MENU BuildMenu()
   oWnd:SetFont( oFnt )

   @ 20, 20 XBROWSE oBrwG SIZE -20,-20 PIXEL OF oWnd ;
      DATASOURCE aGraphs COLUMNS 1, 2  ;
      HEADERS "Type ( Double Click View )", "Graph ( Double Click for Zoom and Resize )" ;
      COLSIZES 360, 360 ;
      NOBORDER

   WITH OBJECT oBrwG:aCols[ 2 ]
      :nHeadStrAlign := AL_CENTER
      :cDataType     := 'F'
      :nDataBmpAlign := AL_CENTER
   END

   WITH OBJECT oBrwG
      :lFlatStyle        := .T.
      :l2007             := .F.
      :lRecordSelector   := .F.
      :nColDividerStyle  := LINESTYLE_LIGHTGRAY
      :nRowDividerStyle  := LINESTYLE_LIGHTGRAY
      :lHScroll          := .F.
      :nEditTypes        := EDIT_GET
      :aCols[ 1 ]:bLDClickData  := { | r, c, f, oCol | DlgGraph( oBrwG:aRow[ 1 ], oBrwG:aRow[ 2 ], .F. ) }
      :aCols[ 2 ]:bLDClickData  := { | r, c, f, oCol | DlgGraph( oBrwG:aRow[ 1 ], oBrwG:aRow[ 2 ], .T. ) }
      :aCols[ 2 ]:bRClickData   := { | r, c, f, oCol | MemoEdit( oBrwG:aRow[ 2 ], oBrwG:aRow[ 1 ] ) }
      :nRowHeight        := 134 + 9
      :nStretchCol       := 2
      //
      :CreateFromCode()
   END

   ACTIVATE WINDOW oWnd
   RELEASE FONT oFnt

Return nil

//----------------------------------------------------------------------------//

function BuildMenu()

   local oMenu

   MENU oMenu
      MENUITEM "Acciones"
      MENU
         MENUITEM "Charts Types"
         MENU
            MENUITEM "Maps"      ACTION ( oBrwG:nArrayAt :=  1, oBrwG:Refresh() )
            MENUITEM "Qr Code"   ACTION ( oBrwG:nArrayAt :=  5, oBrwG:Refresh() )
            MENUITEM "Pie"
            MENU
            MENUITEM "3D"        ACTION ( oBrwG:nArrayAt :=  8, oBrwG:Refresh() )
            MENUITEM "Plain"     ACTION ( oBrwG:nArrayAt := 14, oBrwG:Refresh() )
            ENDMENU
            MENUITEM "Bar"
            MENU
            MENUITEM "Horizont." ACTION ( oBrwG:nArrayAt := 20, oBrwG:Refresh() )
            MENUITEM "Vertical"  ACTION ( oBrwG:nArrayAt := 26, oBrwG:Refresh() )
            ENDMENU
            MENUITEM "Lines"     ACTION ( oBrwG:nArrayAt := 32, oBrwG:Refresh() )
            MENUITEM "O-Metter"  ACTION ( oBrwG:nArrayAt := 41, oBrwG:Refresh() )
            MENUITEM "Formulas"  ACTION ( oBrwG:nArrayAt := 44, oBrwG:Refresh() )
            MENUITEM "Venn"      ACTION ( oBrwG:nArrayAt := 38, oBrwG:Refresh() )
            MENUITEM "Scatter"   ACTION ( oBrwG:nArrayAt := 48, oBrwG:Refresh() )
            MENUITEM "Radar"     ACTION ( oBrwG:nArrayAt := 52, oBrwG:Refresh() )
            MENUITEM "GraphViz"  ACTION ( oBrwG:nArrayAt := 55, oBrwG:Refresh() )
            MENUITEM "Dyn. Icon"
            MENU
               MENUITEM "Bubbles"
               MENU
                  MENUITEM "Normal"     ACTION ( oBrwG:nArrayAt := 63, oBrwG:Refresh() )
                  MENUITEM "Edge Style" ACTION ( oBrwG:nArrayAt := 68, oBrwG:Refresh() )
                  SEPARATOR
                  MENUITEM "Normal Icon"     ACTION ( oBrwG:nArrayAt := 80, oBrwG:Refresh() )
                  MENUITEM "Edge Style Icon" ACTION ( oBrwG:nArrayAt := 85, oBrwG:Refresh() )
                  SEPARATOR
                  MENUITEM "Normal Shadow"     ACTION ( oBrwG:nArrayAt := 97, oBrwG:Refresh() )
                  MENUITEM "Edge Style Shadow" ACTION ( oBrwG:nArrayAt := 101, oBrwG:Refresh() )
               ENDMENU
               MENUITEM "Pins"                 ACTION ( oBrwG:nArrayAt := 150, oBrwG:Refresh() )
               MENUITEM "Fun Notes"
               MENU
                  MENUITEM "Big"
                  MENU
                  MENUITEM "Fun Notes No Title"   ACTION ( oBrwG:nArrayAt := 103, oBrwG:Refresh() )
                  MENUITEM "Fun Notes With Title" ACTION ( oBrwG:nArrayAt := 109, oBrwG:Refresh() )
                  ENDMENU
                  MENUITEM "Small"
                  MENU
                  MENUITEM "Fun Notes No Title"   ACTION ( oBrwG:nArrayAt := 115, oBrwG:Refresh() )
                  MENUITEM "Fun Notes With Title" ACTION ( oBrwG:nArrayAt := 121, oBrwG:Refresh() )
                  ENDMENU
               ENDMENU
               MENUITEM "Weather Notes"           ACTION ( oBrwG:nArrayAt := 135, oBrwG:Refresh() )
               MENUITEM "OutLine Text"            ACTION ( oBrwG:nArrayAt := 127, oBrwG:Refresh() )
               MENUITEM "OutLine Icons - Text"    ACTION ( oBrwG:nArrayAt := 131, oBrwG:Refresh() )
            ENDMENU
         ENDMENU
         MENUITEM "Print" ACTION oBrwG:Report()
         SEPARATOR
         MENUITEM "Salir" ACTION oWnd:End()
      ENDMENU
   ENDMENU

return oMenu

//----------------------------------------------------------------------------//

Function DlgGraph( cTit, cFile, lResize )

   local oDlg
   local oBttG
   local nPos1
   local nPos2
   local nW        := 595
   local nH        := 530
   local cStr
   DEFAULT cTit    := "Visor Graph"
   DEFAULT cFile   := ""
   DEFAULT lResize := .T.
   
   if !Empty( cFile )
      if lResize
         nPos1  := At( "chs=", cFile )
         if !Empty( nPos1 )
            nPos2  := At( "&", Right( cFile, Len( cFile ) - ( nPos1 + 3 ) ) )
            cStr   := Substr( cFile, nPos1, nPos2 + 3 )
            cFile  := StrTran( cFile, cStr, "chs=" + AllTrim( Str( nW - 6 ) ) + "x" + AllTrim( Str( nH - 41 ) ) ) //+ "589x489" ) //
         endif
      endif
      DEFINE DIALOG oDlg TITLE cTit SIZE nW, nH TRUEPIXEL //495
         oDlg:lHelpIcon   := .F.
         //@ 2, 2 BTNBMP oBttG SIZE nW - 5, nH - 40 OF oDlg PIXEL FLAT NOROUND NOBORDER ;  //TRANSPARENT 
         //   FILE cFile
         @ 2, 2 XIMAGE oBttG SIZE nW - 5, nH - 40 OF oDlg NOBORDER ;  //TRANSPARENT 
            SOURCE cFile

         @ 498, 005 BTNBMP PROMPT "Rotate" ;
            SIZE 100,30 PIXEL OF oDlg FLAT ACTION ( oBttG:Rotate( 10 ) ) NOROUND //NOBORDER

         @ 498, 115 BTNBMP PROMPT "Save Mod." ;
            SIZE 100,30 PIXEL OF oDlg FLAT ACTION SaveImgMod( oBttG, , .T. ) ;
            NOROUND
            //WHEN ( if( oBttG:nZoom == 1 .and. oBttG:nRotate == 0, .F., .T. ) ) // not modified
/*
         @ 498, 245 BTNBMP PROMPT "Copy" ;
            SIZE 100,30 PIXEL OF oDlg FLAT ;
            ACTION GDIPLUSHBITMAPTOCLIPBOARD( oBttG:GetHBitmap(), oBttG:hWnd ) ;
            NOROUND
*/
         @ 498, 375 BTNBMP PROMPT "Save" ;
            SIZE 100,30 PIXEL OF oDlg FLAT ACTION SaveImgeGraph( , oBttG:aPalBmp[ 1 ] ) ;
            NOROUND
            //ACTION SaveImgeGraph( , oBttG:hBitmap1 )

         @ 498, 485 BTNBMP PROMPT "Exit" ;
            SIZE 100,30 PIXEL OF oDlg FLAT ACTION oDlg:End() ;
            NOROUND

         ACTIVATE DIALOG oDlg CENTERED
   endif

Return nil

//----------------------------------------------------------------------------//

Function SaveImgeGraph( cFile, hBitmap )

   local oBmp    := GdiBmp():New()
   DEFAULT cFile := cGetFile32( "Png file (*.png) |*.png|",;
                                "Save as", 0, ;
                                 hb_CurDrive() + ":\" + CurDir(), .T., .T. )
   if !Empty( cFile )
      if Empty( cFileExt( cFile ) )
         cFile   += ".png"
      endif
      oBmp:hBmp  := GdiPlusCreateImageFromhBitmap( hBitmap )
      oBmp:Save( cFile )
      oBmp:End()
   endif

Return nil

//----------------------------------------------------------------------------//

Function SaveImgMod( oImg, cFile, lDimImg )

   local lRet       := .F.
   local oBmp
   local oRect
   DEFAULT lDimImg  := .F.
   DEFAULT cFile := cGetFile32( "Png file (*.png) |*.png|",;
                                "Save as", 0, ;
                                 hb_CurDrive() + ":\" + CurDir(), .T., .T. )
   if !Empty( cFile )
      if Empty( cFileExt( cFile ) )
         cFile   += ".png"
      endif
      oRect      := if( lDimImg, oImg:oRect, oImg:GetCliRect() )
      oBmp       := GdiBmp():New()
      oBmp:hBmp  := GDIPLUSCAPTURERECTWND( oImg:hWnd, ;
                       oRect:nTop  + if( oImg:lBorder, 1, 0 ), ;
                       oRect:nLeft + if( oImg:lBorder, 1, 0 ), ;
                       oRect:nRight - oRect:nLeft - 1 - if( oImg:lBorder, 1, 0 ), ;
                       oRect:nBottom - oRect:nTop - 1 - if( oImg:lBorder, 1, 0 ) )
      lRet  := oBmp:Save( cFile )
      oBmp:End()
   endif

Return lRet

//----------------------------------------------------------------------------//
Function QrCode1()

   local oG
   local nW     := 128
   local nH     := 128
   local cText  := "Cristobal Navarro"
   local cEnc   := ""
   local cLev   := ""
   local nMarg  := 0
   oG    := TGQrCode():New( nW, nH, cText, cEnc, cLev, nMarg )

Return oG:Activate()

//----------------------------------------------------------------------------//

Function QrCode2()

   local oG
   local nW     := 128
   local nH     := 128
   local cText  := "Cristobal Navarro"
   local cEnc   := ""
   local cLev   := ""
   local nMarg  := 10
   oG    := TGQrCode():New( nW, nH, cText, cEnc, cLev, nMarg )

Return oG:Activate()

//----------------------------------------------------------------------------//

Function QrCode3()

   local oG
   local nW     := 128
   local nH     := 128
   local cText  := "Cristobal Navarro"
   local cEnc   := ""
   local cLev   := ""
   local nMarg  := 5
   local cColor := "FF0000"
   oG    := TGQrCode():New( nW, nH, cText, cEnc, cLev, nMarg, cColor )

Return oG:Activate()

//----------------------------------------------------------------------------//

Function Pie1( l3d )

   local cRet     := ""
   local oG
   local lConcent := .F.
   local nW       := 128 * 3
   local nH       := 128
   local cTit     := "Cristobal Navarro" + CRLF + "Pie Graph"
   local uAttrT   := ""
   local nRot     := 0
   local aLabels  := { "One", "Two", "Three", "Four" }
   local aData    := { 10,  20, 30, 40 }
   local aColors  := { "EF3886" }  // One color: gradient of datas
   local uAlignL  := ""
   local uAttrL   := ""
   local aSeries
   DEFAULT l3d    := .T.
   if !l3d
      aLabels  := { "One", "Two", "Three", "Four", "One1", "Two1", "Three1", "Four1", "Five1" }
      aData    := { { -1, -1, -1, -1, -1 }, { 10, 20, 30, 40, 50 } }  //{ 10,  20, 30, 40 }
      aColors  := "F0000F,00FF00"  // One color: gradient of datas
      lConcent := .T.
   endif
   oG    := TGPie():New( l3d, lConcent, nW, nH, cTit, nRot, aLabels, aData, ;
                         aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()
   //? cRet
Return cRet

//----------------------------------------------------------------------------//

Function Pie2( l3d )

   local cRet     := ""
   local oG
   local lConcent := .F.
   local nW       := 128 * 3
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := ""
   local nRot     := 0
   local aLabels  := { "One", "Two", "Three", "Four" }
   local aData    := { 10,  20, 30, 40 }
   local aColors  := { "0000FF", "00FF00" }   // gradient with 2 colors
   local uAlignL  := "r"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := ""
   local aSeries
   DEFAULT l3d    := .T.
   oG    := TGPie():New( l3d, lConcent, nW, nH, cTit, nRot, aLabels, aData, ;
                         aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Pie3( l3d )

   local cRet     := ""
   local oG
   local lConcent := .F.
   local nW       := 128 * 3
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := ""
   local nRot     := 0
   local aLabels  := { "One", "Two", "Three", "Four" }
   local aData    := { 10,  20, 30, 40 }
   local aColors  := { "0072C6", "EF3886", "7D5C31", "883886" }
   local uAlignL  := "bv|r"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := ""
   local aSeries
   DEFAULT l3d    := .T.
   oG    := TGPie():New( l3d, lConcent, nW, nH, cTit, nRot, aLabels, aData, ;
                         aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Pie4( l3d )

   local cRet     := ""
   local oG
   local lConcent := .F.
   local nW       := 128 * 3
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := ""
   local nRot     := 0
   local aLabels  := { "One", "Two", "Three", "Four" }
   local aData    := { 10,  20, 30, 40 }
   local aColors  := { "0072C6", "EF3886", "7D5C31", "883886" }
   local uAlignL  := "b"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := ""
   local aSeries
   DEFAULT l3d    := .T.
   oG    := TGPie():New( l3d, lConcent, nW, nH, cTit, nRot, aLabels, aData, ;
                         aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Pie5( l3d )

   local cRet     := ""
   local oG
   local lConcent := .F.
   local nW       := 128 * 3
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := ""
   local nRot     := 60
   local aLabels  := { "One", "Two", "Three", "Four" }
   local aData    := { 10,  20, 30, 40 }
   local aColors  := { "FF0000", "00FF00", "0000FF", "883886" }
   local uAlignL  := "l"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := "0072C6,14"
   local aSeries
   DEFAULT l3d    := .T.
   oG    := TGPie():New( l3d, lConcent, nW, nH, cTit, nRot, aLabels, aData, ;
                         aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Pie6( l3d )

   local cRet     := ""
   local oG
   local lConcent := .F.
   local nW       := 128 * 3
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := "883886,24,r"      // color, size font, align
   local nRot     := 0
   local aLabels  := { "One", "Two", "Three", "Four" }
   local aData    := { 10,  20, 30, 40 }
   local aColors  := { "0072C6", "EF3886", "7D5C31", "883886" }
   local uAlignL  := "l"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := { "7D5C31", "18" }        // color, size font
   local aSeries
   DEFAULT l3d    := .T.
   oG    := TGPie():New( l3d, lConcent, nW, nH, cTit, nRot, aLabels, aData, ;
                         aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Bar1( lVert )

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro" + CRLF + "Bar Graph"
   local uAttrT   := ""
   local aLabels  := { "One", "Two", "Three", "Four" }
   local aData    := { 10,  20, 30, 40 }
   local aColors  := { "EF3886" }  // One color: gradient of datas
   local uAlignL  := ""
   local uAttrL   := ""
   local aSeries
   DEFAULT lVert  := .F.
   if lVert
      aLabels  := { "One", "Two", "Three", "Four" }
      aData    := { { 10,  20, 30, 40 }, { 30, 50, 60, 10 } }
      aColors  := { "0000FF,EF3886", "FF0000,00FF00", "00FF00,EF3886", "F0000F,FF0000" }  // One color: gradient of datas
   endif
   oG    := TGBar():New( lVert, nW, nH, cTit, aLabels, aData, ;
                         aColors, uAttrT, uAlignL, uAttrL, aSeries, , "g")  //g  s  o
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Bar2( lVert )

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := ""
   local aLabels  := { "One", "Two", "Three", "Four" }
   local aData    := { 10,  20, 30, 40 }
   local aColors  := { "0000FF", "00FF00" }   // gradient with 2 colors
   local uAlignL  := "r"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := ""
   local aSeries
   DEFAULT lVert   := .F.
   oG    := TGBar():New( lVert, nW, nH, cTit, aLabels, aData, ;
                         aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Bar3( lVert )

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := ""
   local aLabels  := { "One", "Two", "Three", "Four" }
   local aData    := { 10,  20, 30, 40 }
   local aColors  := { "0072C6", "EF3886", "7D5C31", "883886" }
   local uAlignL  := "bv|r"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := ""
   local aSeries
   DEFAULT lVert  := .F.
   oG    := TGBar():New( lVert, nW, nH, cTit, aLabels, aData, ;
                         aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Bar4( lVert )

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := ""
   local aLabels  := { "One", "Two", "Three", "Four" }
   local aData    := { 10,  20, 30, 40 }
   local aColors  := { "0072C6", "EF3886", "7D5C31", "883886" }
   local uAlignL  := "b"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := ""
   local aSeries
   DEFAULT lVert  := .F.
   oG    := TGBar():New( lVert, nW, nH, cTit, aLabels, aData, ;
                         aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Bar5( lVert )

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := ""
   local aLabels  := { "One", "Two", "Three", "Four" }
   local aData    := { 10,  20, 30, 40 }
   local aColors  := { "FF0000", "00FF00", "0000FF", "883886" }
   local uAlignL  := "l"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := "0072C6,14"
   local aSeries
   DEFAULT lVert  := .F.
   oG    := TGBar():New( lVert, nW, nH, cTit, aLabels, aData, ;
                         aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Bar6( lVert )

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := "883886,24,r"      // color, size font, align
   local aLabels  := { "One", "Two", "Three", "Four" }
   local aData    := { 10,  20, 30, 40 }
   local aColors  := { "0072C6", "EF3886", "7D5C31", "883886" }
   local uAlignL  := "l"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := { "7D5C31", "18" }        // color, size font
   local aSeries
   DEFAULT lVert  := .F.
   oG    := TGBar():New( lVert, nW, nH, cTit, aLabels, aData, ;
                         aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Lin1( lAxis )

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro" + CRLF + "Line Graph"
   local uAttrT   := ""
   local aLabels  := { "One", "Two", "Three", "Four" }
   local aData    := { 10,  20, 30, 40 }
   local aColors  := { "EF3886" }  // One color: gradient of datas
   local uAlignL  := ""
   local uAttrL   := ""
   local aSeries
   DEFAULT lAxis  := .T.
   oG    := TGLine():New( lAxis, nW, nH, cTit, aLabels, aData, ;
                         aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Lin2( lAxis )

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := ""
   local aLabels  := { "One", "Two", "Three", "Four" }
   local aData    := { 10,  20, 30, 40 }
   local aColors  := { "0000FF", "00FF00" }   // gradient with 2 colors
   local uAlignL  := "r"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := ""
   local aSeries
   DEFAULT lAxis  := .T.
   oG    := TGLine():New( lAxis, nW, nH, cTit, aLabels, aData, ;
                         aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Lin3( lAxis )

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := "883886,24,r"      // color, size font, align
   local aLabels  := { "One", "Two", "Three", "Four" }
   local aData    := { 10,  20, 30, 40 }
   local aColors  := { "0072C6", "EF3886", "7D5C31", "883886" }
   local uAlignL  := "b"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := ""
   local aSeries
   DEFAULT lAxis  := .T.
   oG    := TGLine():New( lAxis, nW, nH, cTit, aLabels, aData, ;
                         aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Ven1()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro" + CRLF + "Venn Graph"
   local uAttrT   := ""
   local aLabels  := { "One", "Two", "Three" }
   local aData    := { 100, 80, 60, 30, 20, 30, 10 }
   local aColors  := { "EF3886" }  // One color: gradient of datas
   local uAlignL  := ""
   local uAttrL   := ""
   local aSeries
   oG    := TGVenn():New( nW, nH, cTit, aLabels, aData, ;
                         aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Ven2()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := ""
   local aLabels  := { "One", "Two", "Three" }
   local aData    := { 100, 40, 80, 10, 20, 30, 10 }
   local aColors  := { "0000FF", "00FF00" }
   local uAlignL  := "r"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := ""
   local aSeries
   oG    := TGVenn():New( nW, nH, cTit, aLabels, aData, ;
                         aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Ven3()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := "883886,24,r"      // color, size font, align
   local aLabels  := { "One", "Two", "Three" }
   local aData    := { 100,  80, 40, 10, 20, 30, 10 }
   local aColors  := { "0000FFFF", "00FF0066", "FF000066" }  // Last 2 digit transparency: FF to 00 ( transparent )
   local uAlignL  := "b"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := ""
   local aSeries
   oG    := TGVenn():New( nW, nH, cTit, aLabels, aData, ;
                         aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Met1()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := ""
   local aLabels  := { "One" }
   local aData    := { 60 }
   local aColors  := { "0000FFFF" }  // Last 2 digit transparency: FF to 00 ( transparent )
   local uAlignL  := ""  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := ""
   local aSeries
   oG    := TOMetter():New( nW, nH, cTit, aLabels, aData, ;
                            aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Met2()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := ""
   local aLabels  := { "One", "Two", "Three" }
   local aData    := { 100, 60, 30 }
   local aColors  := { "0000FFFF", "00FF0066" }  // Last 2 digit transparency: FF to 00 ( transparent )
   local uAlignL  := "r"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := ""
   local aSeries
   oG    := TOMetter():New( nW, nH, cTit, aLabels, aData, ;
                            aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Met3()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := "883886,24,r"      // color, size font, align
   local aLabels  := { "One", "Two", "Three" }
   local aData    := { 100, 60, 30 }
   local aColors  := { "0000FFFF", "00FF0066", "FF000066" }  // Last 2 digit transparency: FF to 00 ( transparent )
   local uAlignL  := "b"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := ""
   local aSeries
   oG    := TOMetter():New( nW, nH, cTit, aLabels, aData, ;
                            aColors, uAttrT, uAlignL, uAttrL, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function For1()

   local cRet     := ""
   local oG
   local nW       := 128 * 1
   local nH       := 64
   local aData    := { "a^2%2Bb^2=c^2" }   //a2 + b2 = c2  / 2B Hex. code "+"
   local cColorT  := "FFFFFF66"     // Last 2 digit transparency: FF to 00 ( transparent )
   local cColorB  := "bg,s,FF0000"  // Last 2 digit transparency: FF to 00 ( transparent )
   // a ( Image transparency ) / bg ( Background fill ), [s]olid, colors
   oG    := TGFormula():New( nW, nH, aData, cColorB, cColorT )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function For2()

   local cRet     := ""
   local oG
   local nW       := 128 * 1
   local nH       := 64
   local aData    := { "a^2%2Bb^2=c^2" }   //a2 + b2 = c2  / 2B Hex. code "+"
   local cColorT  := "00FF00"     // Last 2 digit transparency: FF to 00 ( transparent )
   local cColorB  := { "bg", "", "FF0000" } // Last 2 digit transparency: FF to 00 ( transparent )
   // a ( Image transparency ) / bg ( Background fill ), [s]olid, colors
   oG    := TGFormula():New( nW, nH, aData, cColorB, cColorT )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function For3()

   local cRet     := ""
   local oG
   local nW       := 128 * 1
   local nH       := 64
   local aData    := { "$x_{1,2}={-b\pm\sqrt{b^2-4\times a\times c} \over {2 \times a}}$" }  //LexTex
   //https://es.wikipedia.org/wiki/TeX
   local cColorT  := "0000FF"     // Last 2 digit transparency: FF to 00 ( transparent )
   local cColorB  := { "a", "", "FF0000" } // Last 2 digit transparency: FF to 00 ( transparent )
   // a ( Image transparency ) / bg ( Background fill ), [s]olid, colors
   oG    := TGFormula():New( nW, nH, aData, cColorB, cColorT )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function For4()

   local cRet     := ""
   local oG
   local nW       := 128 * 1
   local nH       := 64
   local aData    := { "a^2%2Bb^2=c^2" }   //a2 + b2 = c2  / 2B Hex. code "+"
   local cColorT  := "0000FF"     // Last 2 digit transparency: FF to 00 ( transparent )
   local cColorB  := { "bg", "s", "FF0000" } // Last 2 digit transparency: FF to 00 ( transparent )
   //a ( Image transparency ) / bg ( Background fill ), [s]olid, colors
   oG    := TGFormula():New( nW, nH, aData, cColorB, cColorT )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Map1()

   local cRet     := ""
   local cImg
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := "883886,12,c"      // color, size font, align
   local cCenter  := { "-60", "5", "80", "-5" } //zoom area is -60 latitude to 80 latitude, 0 longitude to -35 longitude
   local lFixed   := .T.
   local cRegions := { "CA-BC", "CN", "IT", "GR", "US-UT" } //https://en.wikipedia.org/wiki/ISO_3166-2
   local aLabels  := { "Vancouver", "Beijing", "Torino", "Athens", "Salt+Lake+City" }
   local aColors  := { "B3BCC0", "5781AE", "FF0000", "FFC726", "885E80", "518274" }  // Last 2 digit transparency: FF to 00 ( transparent )
   local uAlignL  := "b"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := { "7D5C31", "12" }        // color, size font
   //local cColorT  := "0000FF"     // Last 2 digit transparency: FF to 00 ( transparent )
   local cColorB  := { "a", "s", "FF0000" } // Last 2 digit transparency: FF to 00 ( transparent )
   local cMarkers := "f2010+Winter,000000,0,0,10|f2008+Summer,000000,0,1,10|" + ;
                     "f2008+Winter,000000,0,2,10,1,:-5:10|f2004+Summer,000000,0,3,10"
   local cBorders := ""
   oG    :=  TGChartMap():New( nW, nH, cCenter, lFixed, cTit, uAttrT, cRegions, aColors, ;
                               aLabels, uAlignL, uAttrL, cColorB, cMarkers, cBorders )
   cRet  := oG:Activate()
   //? cRet
   //? cRet := cRet[ 1 ]
   // ? cImg := WebImage( cRet )
   //? lIsPng( cImg )
   //? ImagePNGFromStr( cImg, , )


Return cRet

//----------------------------------------------------------------------------//

Function Map2()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := "883886,12,c"      // color, size font, align
   local cCenter  := ""  //zoom area is -60 latitude to 80 latitude, 0 longitude to -35 longitude
   local lFixed   := .F.
   local cRegions := { "FR-D", "FR-B", "FR" }  //https://en.wikipedia.org/wiki/ISO_3166-2
   local aLabels  := ""
   local aColors  := { "676767", "FF4444", "44FF44", "4444FF" }  // Last 2 digit transparency: FF to 00 ( transparent )
   local uAlignL  := "b"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := { "7D5C31", "12" }        // color, size font
   local cColorB  := { "bg", "", "FF0000" } // Last 2 digit transparency: FF to 00 ( transparent )
   local cMarkers := "A2010+Winter,000000,0,0,10|A2008+Summer,000000,0,1,10|" + ;
                     "A2008+Winter,000000,0,2,10,1,:-5:10"
   local cBorders := ""
   oG    :=  TGChartMap():New( nW, nH, cCenter, lFixed, cTit, uAttrT, cRegions, aColors, ;
                               aLabels, uAlignL, uAttrL, cColorB, cMarkers, cBorders )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Map3()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := "883886,12,c"      // color, size font, align
   local cCenter  := { "0", "0", "0", "0" } //<left_border>,<right_border>,<top_border>,<bottom_border>
   local lFixed   := .F.
   local cRegions := { "ES-M", "ES-MA", "ES-B" } //https://en.wikipedia.org/wiki/ISO_3166-2
   local aLabels  := { "Madrid", "Malaga", "Barcelona" }
   local aColors  := { "676767", "FF4444", "44FF44", "4444FF" }  // Last 2 digit transparency: FF to 00 ( transparent )
   local uAlignL  := "r"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := { "7D5C31", "12" }        // color, size font
   local cColorT  := "0000FF"     // Last 2 digit transparency: FF to 00 ( transparent )
   local cColorB  := { "a", "", "FF0000" } // Last 2 digit transparency: FF to 00 ( transparent )
   local cMarkers := "tMadrid,000000,0,0,10|tMalaga,000000,0,1,10|" + ;
                     "tBarcelona,000000,0,2,10,1,:-5:10"
   local cBorders := "0,0,20,0"
   oG    :=  TGChartMap():New( nW, nH, cCenter, lFixed, cTit, uAttrT, cRegions, aColors, ;
                               aLabels, uAlignL, uAttrL, cColorB, cMarkers, cBorders )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Map4()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro"
   local uAttrT   := "883886,12,c"      // color, size font, align
   local cCenter  := { "0", "0", "0", "0" } //<left_border>,<right_border>,<top_border>,<bottom_border>
   local lFixed   := .F.
   local cRegions := { "IN-TG", "IN", "ES-MA", "ES" } //https://en.wikipedia.org/wiki/ISO_3166-2
   local aLabels  := { "Telangana", "India", "Malaga", "Spain" }
   local aColors  := { "676767", "FF0000", "44FF44", "4444FF", "883886" }  // Last 2 digit transparency: FF to 00 ( transparent )
   local uAlignL  := "r"  // b  // bv  // t  // tv  // l  // bv|r
   local uAttrL   := { "7D5C31", "12" }        // color, size font
   local cColorT  := "0000FF"     // Last 2 digit transparency: FF to 00 ( transparent )
   local cColorB  := { "bg", "s", "AAAAAA" } // Last 2 digit transparency: FF to 00 ( transparent )
   local cMarkers := "ATelangana,000000,0,1,10|AIndia,000000,0,1,10|" + ;
                     "AMalaga,000000,0,2,10,1,:-5:10|ASpain,000000,0,3,10"
   local cBorders := ""
   oG    :=  TGChartMap():New( nW, nH, cCenter, lFixed, cTit, uAttrT, cRegions, aColors, ;
                               aLabels, uAlignL, uAttrL, cColorB, cMarkers, cBorders )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Sca1()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro " + "Scatter Graph"
   local uAttrT   := "883886,12,l"
   local aLabels  := { "One", "Two" }
   local aData    := "12,87,75,41,23,96,68,71,34,9|98,60,27,34,56,79,58,74,18,76|" + ;
                     "84,23,69,81,47,94,60,93,64,54"
   local aColors  := { "EF3886", "FF0000" }  // 
   local uAlignL  := "r"
   local uAttrL   := ""
   local cMarkers := "d,FF0000,0,-1,15"
   local aSeries
   oG    := TGScatter():New( nW, nH, cTit, aLabels, aData, ;
                             aColors, uAttrT, uAlignL, uAttrL, cMarkers, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Sca2()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro " + "Scatter Graph"
   local uAttrT   := "883886,12,l"
   local aLabels  := { "One", "Two" }
   local aData    := "12,87,75,41,23,96,68,71,34,9|98,60,27,34,56,79,58,74,18,76|" + ;
                     "84,23,69,81,47,94,60,93,64,54"
   local aColors  := { "EF3886", "FF0000" }  // 
   local uAlignL  := "r"
   local uAttrL   := ""
   local cMarkers := "v,FF0000,0,-1,1"
   local aSeries
   oG    := TGScatter():New( nW, nH, cTit, aLabels, aData, ;
                             aColors, uAttrT, uAlignL, uAttrL, cMarkers, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Sca3()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro " + "Scatter Graph"
   local uAttrT   := "883886,12,l"
   local aLabels  := { "One", "Two" }
   local aData    := "12,87,75,41,23,96,68,71,34,9|98,60,27,34,56,79,58,74,18,76|" + ;
                     "84,23,69,81,47,94,60,93,64,54"
   local aColors  := { "EF3886", "FF0000" }  // 
   local uAlignL  := "r"
   local uAttrL   := ""
   local cMarkers := "a,FF0000,0,-1,5"
   local aSeries
   oG    := TGScatter():New( nW, nH, cTit, aLabels, aData, ;
                             aColors, uAttrT, uAlignL, uAttrL, cMarkers, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Sca4()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro " + "Scatter Graph"
   local uAttrT   := "883886,12,l"
   local aLabels  := { "One", "Two", "Three" }
   local aData    := "12,87,75,41,23,96,68,71,34,9|98,60,27,34,56,79,58,74,18,76|" + ;
                     "84,23,69,81,47,94,60,93,64,54|80,50,17,44,66,97,85,47,8,67"
   local aColors  := { "EF3886", "FF0000", "00FF00" }  // 
   local uAlignL  := "r"
   local uAttrL   := ""
   local cMarkers := "c,FF0000,0,-1,10"
   local aSeries
   oG    := TGScatter():New( nW, nH, cTit, aLabels, aData, ;
                             aColors, uAttrT, uAlignL, uAttrL, cMarkers, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Rad1()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro " + "Radar Graph"
   local uAttrT   := "883886,12,r"
   local aLabels  := "0:|One|Two|Three|Four"
   local aData    := "10,20,30,40,50,60,70,80"
   local aColors  := { "FF0000" }  // 
   local uAlignL  := "r"
   local uAttrL   := { "7D5C31", "12" }
   local cMarkers := "" //"d,FF0000,0,-1,15"
   local aSeries
   local lCurve   := .F.
   oG    := TGRadar():New( lCurve, nW, nH, cTit, aLabels, aData, ;
                             aColors, uAttrT, uAlignL, uAttrL, cMarkers, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Rad2()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro " + "Radar Graph"
   local uAttrT   := "883886,12,r"
   local aLabels  := "0:|One|Two|Three|Four"
   local aData    := "10,20,30,40,50"
   local aColors  := { "FF0000" }  // 
   local uAlignL  := ""
   local uAttrL   := ""
   local cMarkers := "d,FF0000,0,-1,4"
   local aSeries
   local lCurve   := .F.
   oG    := TGRadar():New( lCurve, nW, nH, cTit, aLabels, aData, ;
                             aColors, uAttrT, uAlignL, uAttrL, cMarkers, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Rad3()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := "Cristobal Navarro " + "Radar Graph"
   local uAttrT   := "883886,12,r"
   local aLabels  := "0:|One|Two|Three|Four"
   local aData    := "10,20,30,40,50"
   local aColors  := { "FF0000" }  // 
   local uAlignL  := ""
   local uAttrL   := ""
   local cMarkers := "" //"c,FF0000,0,-1,4"
   local aSeries
   local lCurve   := .T.
   oG    := TGRadar():New( lCurve, nW, nH, cTit, aLabels, aData, ;
                             aColors, uAttrT, uAlignL, uAttrL, cMarkers, aSeries )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Viz1()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := ""
   local uAttrT   := ""
   local cCenter  := "dot"
   local lFixed   := .F.
   local aLabels  := "digraph{A->B->C->A}"
   local aColors  := ""
   local cColorB  := ""
   oG    :=  TGraphViz():New( nW, nH, cCenter, lFixed, cTit, uAttrT, aColors, ;
                              aLabels, cColorB )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Viz2()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := ""
   local uAttrT   := ""
   local cCenter  := "neato"
   local lFixed   := .F.
   local aLabels  := "digraph{A->B->C->A}"
   local aColors  := ""
   local cColorB  := ""
   oG    :=  TGraphViz():New( nW, nH, cCenter, lFixed, cTit, uAttrT, aColors, ;
                              aLabels, cColorB )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Viz3()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := ""
   local uAttrT   := ""
   local cCenter  := "twopi"
   local lFixed   := .F.
   local aLabels  := "digraph{A->B->C->A}"
   local aColors  := ""
   local cColorB  := ""
   oG    :=  TGraphViz():New( nW, nH, cCenter, lFixed, cTit, uAttrT, aColors, ;
                              aLabels, cColorB )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Viz4()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := ""
   local uAttrT   := ""
   local cCenter  := "circo"
   local lFixed   := .F.
   local aLabels  := "digraph{A->B->C->A}"
   local aColors  := ""
   local cColorB  := ""
   oG    :=  TGraphViz():New( nW, nH, cCenter, lFixed, cTit, uAttrT, aColors, ;
                              aLabels, cColorB )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Viz5()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := ""
   local uAttrT   := ""
   local cCenter  := "fdp"
   local lFixed   := .F.
   local aLabels  := "digraph{A->B->C->A}"
   local aColors  := ""
   local cColorB  := ""
   oG    :=  TGraphViz():New( nW, nH, cCenter, lFixed, cTit, uAttrT, aColors, ;
                              aLabels, cColorB )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Viz6()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := ""
   local uAttrT   := ""
   local cCenter  := "dot"
   local lFixed   := .F.
   local aLabels  := "graph{One--Two--Three;Two--Four}"
   local aColors  := ""
   local cColorB  := ""
   oG    :=  TGraphViz():New( nW, nH, cCenter, lFixed, cTit, uAttrT, aColors, ;
                              aLabels, cColorB )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Viz7()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := ""
   local uAttrT   := ""
   local cCenter  := "dot"
   local lFixed   := .F.
   local aLabels  := "graph{C_0--H_0[type=s];C_0--H_1[type=s];C_0--H_2[type=s];" + ;
                      "C_0--C_1[type=s];C_1--H_3[type=s];C_1--H_4[type=s];C_1--H_5[type=s]}"
   local aColors  := ""
   local cColorB  := ""
   oG    :=  TGraphViz():New( nW, nH, cCenter, lFixed, cTit, uAttrT, aColors, ;
                              aLabels, cColorB )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Viz8()

   local cRet     := ""
   local oG
   local nW       := 128 * 4
   local nH       := 128
   local cTit     := ""
   local uAttrT   := ""
   local cCenter  := "neato"
   local lFixed   := .F.
   local aLabels  := "graph{One--Two--Three;Two--Four}"
   local aColors  := ""
   local cColorB  := ""
   oG    :=  TGraphViz():New( nW, nH, cCenter, lFixed, cTit, uAttrT, aColors, ;
                              aLabels, cColorB )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Bubble01( lEd, uAlign, uAlignH, lIco, lShad )

   local oG
   local cRet      := ""
   local cTit      := "Hola"
   local uAttrT    := ""
   local cIcon     := ""
   local cFrame
   local lShadow
   local lBig      := .T.
   local cColorT
   local cColorB
   local lEdge
   local cAlignA
   local cAlignHA
   DEFAULT lEd     := .F.
   DEFAULT uAlign  := ""
   DEFAULT uAlignH := ""
   DEFAULT lIco    := .F.
   DEFAULT lShad   := .F.
   lEdge           := lEd
   cAlignA         := uAlign
   cAlignHA        := uAlignH
   if lIco
      cIcon        := "glyphish_id-card" //"civic-building"
   endif
   if lEdge
      cColorB      := NumToHex( METRO_OLIVE )
      if Len( cColorB ) < 6
         cColorB   += Replicate( "0", 6 - Len( cColorB ) )
      endif
      if lBig
         cTit      += CRLF + CRLF + "En un lugar" + CRLF + "de la Mancha   " + CRLF
      else
         cTit      += CRLF + "En un lugar" + CRLF + "de la Mancha   "
      endif
   else
      if !lIco
         lBig      := .F.
      endif
   endif
   lShadow         := lShad
   if lShadow .and. !lEdge
      cColorB      := NumToHex( CLR_WHITE )
      if Len( cColorB ) < 6
         cColorB   += Replicate( "0", 6 - Len( cColorB ) )
      endif
   endif
   oG    := TGBubbles():New( cTit, cIcon, cFrame, lShadow, lBig, cColorT, cColorB, lEdge, cAlignA, cAlignHA )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function FNotes01( cType, lTit, lBig, uAlign )

   local oG
   local cRet      := ""
   local cTit      := "Hola"
   local cColorT
   local lEdge
   local cAlignA
   DEFAULT cType   := "arrow_d" // "balloon" // "pinned_c" // "sticky_y" // "taped_y" // "thought"
   DEFAULT lTit    := .F.
   DEFAULT lBig    := .T.
   DEFAULT uAlign  := "l"
   cAlignA         := uAlign
   cColorT      := NumToHex( METRO_OLIVE )
   if Len( cColorT ) < 6
      cColorT   += Replicate( "0", 6 - Len( cColorT ) )
   endif
   cTit         += CRLF + CRLF + "En un lugar" + CRLF + "de la Mancha   " + CRLF
   oG    := TGFunNotes():New( cType, cTit, lBig, cColorT, lTit, cAlignA )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function OutTxt01( lBold, uAlign )

   local oG
   local cRet      := ""
   local cTit      := "Hola"
   local cColorT   := NumToHex( CLR_YELLOW ) + "00"
   local cColorB   := "FF0000"
   local cSizeH    := "20"
   local cAlignA
   DEFAULT lBold   := .F.
   DEFAULT uAlign  := "l"
   cAlignA         := uAlign
   cTit         += CRLF + "En un lugar" + CRLF + "de la Mancha"
   oG    := TGOutLineText():New( cTit, cColorB, cColorT, cSizeH, lBold, cAlignA )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function OutTxtIco01( cPos, cSizeI, uAlign )

   local oG
   local cRet      := ""
   local cTit      := "Hola"
   local cColorT   := NumToHex( CLR_YELLOW ) + "00"
   local cColorB   := "000000"
   local cSizeH    := "20"
   local cColorIB  := "0000FF"
   local cIcon
   local cAlignA
   DEFAULT cPos    := "below"  // "above"  // "left"  // "right"
   DEFAULT cSizeI  := "12"
   DEFAULT uAlign  := "l"
   cAlignA         := uAlign
   oG    := TGOutLineIcons():New( cPos, cTit, cColorB, cColorT, cSizeH, cIcon, cSizeI, cColorIB, cAlignA )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Weather01( cType, cIcon )

   local oG
   local cRet      := ""
   local cTit      := " - Previsiones"
   local cColorT
   local lEdge
   local cAlignA
   DEFAULT cType   := "arrow_d" // "balloon" // "pinned_c" // "sticky_y" // "taped_y" // "thought"
   DEFAULT cIcon   := "sunny"
   cTit         += CRLF + "Castilla" + CRLF + "La Mancha"

   oG    := TGWeatherNotes():New( cType, cTit, cIcon )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Ping01( cFactor, cIcon, cStyle, lShadow, lBold )

   local oG
   local cRet        := ""
   local cTit        := "P"
   local cColorT     := "0000FF"
   local cColorB     := "FFFFFF"
   local cSizeH      := "20"
   local nDegr
   local cColorS
   local cType       // "xpin"
   DEFAULT cFactor   := "1"
   DEFAULT cIcon     := ""    // "computer"
   DEFAULT cStyle    := ""    // pin  // pin_star  // pin_sleft  // pin_sright
   DEFAULT lShadow   := .F.
   DEFAULT lBold     := .F.
   if Val( cFactor ) != 1
      cTit           := "P" + CRLF + "F"
   endif
   if !Empty( cIcon )
      cTit           := nil
   endif
   oG    := TGPins():New( cType, cStyle, cTit, cIcon, lShadow, cColorT, cColorB, cFactor, nDegr, cSizeH, lBold, cColorS )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Ping02( cFactor, cIcon, cStyle, lShadow, lBold )

   local oG
   local cRet        := ""
   local cTit        := "P"
   local cColorT     := "0000FF"
   local cColorB     := "FF0000"
   local cSizeH      := "20"
   local nDegr
   local cColorS     := NumToHex( CLR_YELLOW ) + "00"
   local cType       := "xpin"
   DEFAULT cFactor   := "1"
   DEFAULT cIcon     := "computer"
   DEFAULT cStyle    := "pin_star"    // pin  // pin_star  // pin_sleft  // pin_sright
   DEFAULT lShadow   := .T.
   DEFAULT lBold     := .F.
   if Val( cFactor ) != 1
      cTit           := "P" + CRLF + "F"
   endif
   if !Empty( cIcon )
      cTit           := nil
   endif
   oG    := TGPins():New( cType, cStyle, cTit, cIcon, lShadow, cColorT, cColorB, cFactor, nDegr, cSizeH, lBold, cColorS )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Ping03( cFactor, cIcon, cStyle, lShadow, lBold )

   local oG
   local cRet        := ""
   local cTit        := "P"
   local cColorT     := "0000FF"
   local cColorB     := "FFFFFF"
   local cSizeH      := "20"
   local nDegr
   local cColorS
   local cType       := "xpin"
   DEFAULT cFactor   := "1"
   DEFAULT cIcon     := "" //"computer"
   DEFAULT cStyle    := "pin_sleft"    // pin  // pin_star  // pin_sleft  // pin_sright
   DEFAULT lShadow   := .T.
   DEFAULT lBold     := .F.
   if Val( cFactor ) != 1
      cTit           := "P" + CRLF + "F"
   endif
   if !Empty( cIcon )
      cTit           := nil
   endif
   oG    := TGPins():New( cType, cStyle, cTit, cIcon, lShadow, cColorT, cColorB, cFactor, nDegr, cSizeH, lBold, cColorS )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Ping04( cFactor, cIcon, cStyle, lShadow, lBold )

   local oG
   local cRet        := ""
   local cTit        := "P"
   local cColorT     := "0000FF"
   local cColorB     := "FFFFFF"
   local cSizeH      := "20"
   local nDegr
   local cColorS
   local cType       := "xpin"
   DEFAULT cFactor   := "1"
   DEFAULT cIcon     := "" //"computer"
   DEFAULT cStyle    := "pin_sright"    // pin  // pin_star  // pin_sleft  // pin_sright
   DEFAULT lShadow   := .T.
   DEFAULT lBold     := .F.
   if Val( cFactor ) != 1
      cTit           := "P" + CRLF + "F"
   endif
   if !Empty( cIcon )
      cTit           := nil
   endif
   oG    := TGPins():New( cType, cStyle, cTit, cIcon, lShadow, cColorT, cColorB, cFactor, nDegr, cSizeH, lBold, cColorS )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Ping05( cFactor, cIcon, cStyle, lShadow, lBold )

   local oG
   local cRet        := ""
   local cTit        := "P"
   local cColorT     := "0000FF"
   local cColorB     := "00FFFF"
   local cSizeH      := "32"
   local nDegr       := "45"
   local cColorS
   local cType       // "xpin"
   DEFAULT cFactor   := "1"
   DEFAULT cIcon     := ""    // "computer"
   DEFAULT cStyle    := ""    // pin  // pin_star  // pin_sleft  // pin_sright
   DEFAULT lShadow   := .F.
   DEFAULT lBold     := .T.
   if Val( cFactor ) != 1
      cTit           := "P" + CRLF + "F"
   endif
   if !Empty( cIcon )
      cTit           := nil
   endif
   oG    := TGPins():New( cType, cStyle, cTit, cIcon, lShadow, cColorT, cColorB, cFactor, nDegr, cSizeH, lBold, cColorS )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Ping06( cFactor, cIcon, cStyle, lShadow, lBold )

   local oG
   local cRet        := ""
   local cTit        := "Prueba"
   local cColorT     := "0000FF"
   local cColorB     := "C6E7DE"
   local cSizeH      := "11"
   local nDegr       := "180"
   local cColorS
   local cType       := "spin"
   DEFAULT cFactor   := "1.7"
   DEFAULT cIcon     := ""    // "computer"
   DEFAULT cStyle    := ""    // pin  // pin_star  // pin_sleft  // pin_sright
   DEFAULT lShadow   := .F.
   DEFAULT lBold     := .F.
   if !Empty( cIcon )
      cTit           := nil
   endif
   oG    := TGPins():New( cType, cStyle, cTit, cIcon, lShadow, cColorT, cColorB, cFactor, nDegr, cSizeH, lBold, cColorS )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Ping07( cFactor, cIcon, cStyle, lShadow, lBold )

   local oG
   local cRet        := ""
   local cTit        := "Primera linea" + CRLF + "Segunda Linea"
   local cColorT     := "0000FF"
   local cColorB     := "FFFF42"
   local cSizeH      := "12"
   local nDegr       := "-45"
   local cColorS
   local cType       := "spin"
   DEFAULT cFactor   := "3"
   DEFAULT cIcon     := ""    // "computer"
   DEFAULT cStyle    := ""    // pin  // pin_star  // pin_sleft  // pin_sright
   DEFAULT lShadow   := .F.
   DEFAULT lBold     := .T.
   if !Empty( cIcon )
      cTit           := nil
   endif
   oG    := TGPins():New( cType, cStyle, cTit, cIcon, lShadow, cColorT, cColorB, cFactor, nDegr, cSizeH, lBold, cColorS )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//

Function Ping08( cFactor, cIcon, cStyle, lShadow, lBold )

   local oG
   local cRet        := ""
   local cTit        := ""
   local cColorT     := "0000FF"   // Not applied
   local cColorB     := "FFFFFF"   // Not applied
   local cSizeH      := ""
   local nDegr
   local cColorS
   local cType       := "xpin"
   DEFAULT cFactor   := ""
   DEFAULT cIcon     := ""
   DEFAULT cStyle    := "pin_sleft"    // pin  // pin_star  // pin_sleft  // pin_sright
   DEFAULT lShadow   := .T.            // Only shadow -> icon and text empty
   DEFAULT lBold     := .F.
   oG    := TGPins():New( cType, cStyle, cTit, cIcon, lShadow, cColorT, cColorB, cFactor, nDegr, cSizeH, lBold, cColorS )
   cRet  := oG:Activate()

Return cRet

//----------------------------------------------------------------------------//
